# SwaggerClient-php
Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/)

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.2
- Build package: io.swagger.codegen.languages.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com//.git"
    }
  ],
  "require": {
    "/": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: api_key
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('key', 'Bearer');

$apiInstance = new Swagger\Client\Api\CustomerApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$companyid = "companyid_example"; // string | Company ID
$firstname = "firstname_example"; // string | Customer First Name
$lastname = "lastname_example"; // string | Customer Last Name
$sendtype = "1"; // string | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\"
$email = "email_example"; // string | Customer Email
$mobile = "mobile_example"; // string | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input
$address = "address_example"; // string | Customer Postal Address
$zipcode = "zipcode_example"; // string | Customer Zipcode
$city = "city_example"; // string | Customer City
$state = "state_example"; // string | Customer State / Province / Region
$country = "country_example"; // string | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt
$language = "language_example"; // string | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages
$notes = "notes_example"; // string | Additional Customer Notes

try {
    $result = $apiInstance->createCustomerAutomatic($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling CustomerApi->createCustomerAutomatic: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *https://reputationcrm.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CustomerApi* | [**createCustomerAutomatic**](docs/Api/CustomerApi.md#createcustomerautomatic) | **POST** /createCustomerAutomatic | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
*CustomerApi* | [**createCustomerAutomaticWithDelayReviewRequest**](docs/Api/CustomerApi.md#createcustomerautomaticwithdelayreviewrequest) | **POST** /createCustomerAutomaticWithDelayReviewRequest | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
*CustomerApi* | [**createCustomerImmediateFirstReviewRequest**](docs/Api/CustomerApi.md#createcustomerimmediatefirstreviewrequest) | **POST** /createCustomerImmediateFirstReviewRequest | Create a Customer AND Feedback / Review Requests
*CustomerApi* | [**createCustomerManualScheduleOneReviewRequest**](docs/Api/CustomerApi.md#createcustomermanualscheduleonereviewrequest) | **POST** /createCustomerManualScheduleOneReviewRequest | Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
*CustomerApi* | [**deleteCustomer**](docs/Api/CustomerApi.md#deletecustomer) | **DELETE** /deleteCustomer | Delete ONE Customer record
*CustomerApi* | [**getAllCustomersBycompanyId**](docs/Api/CustomerApi.md#getallcustomersbycompanyid) | **GET** /getAllCustomersBycompanyId | Get Information on ALL Customers of a Company / Location / Feedback Page
*CustomerApi* | [**getCustomersWhoHaveNotYetSubmittedReview**](docs/Api/CustomerApi.md#getcustomerswhohavenotyetsubmittedreview) | **GET** /getCustomersWhoHaveNotYetSubmittedReview | Get a list of Customers who have not yet submitted their Review / Feedback
*CustomerApi* | [**getSingleCustomer**](docs/Api/CustomerApi.md#getsinglecustomer) | **GET** /getSingleCustomer | Get Information of ONE Customer
*CustomerApi* | [**updateCustomer**](docs/Api/CustomerApi.md#updatecustomer) | **PUT** /updateCustomer | Update the record of ONE Customer
*EmailSMSStatsApi* | [**getEmailSmsSentCount**](docs/Api/EmailSMSStatsApi.md#getemailsmssentcount) | **GET** /getEmailSmsSentCount | Email / SMS sent
*EmailSMSStatsApi* | [**getEmailSmsSentLimit**](docs/Api/EmailSMSStatsApi.md#getemailsmssentlimit) | **GET** /getEmailSmsSentLimit | Email / SMS Limit
*QueueApi* | [**deleteQueueByCustomerId**](docs/Api/QueueApi.md#deletequeuebycustomerid) | **DELETE** /deleteQueueByCustomerId | Delete requests of a customer
*QueueApi* | [**deleteQueueBycompanyId**](docs/Api/QueueApi.md#deletequeuebycompanyid) | **DELETE** /deleteQueueBycompanyId | Delete requests of a company
*QueueApi* | [**getQueueBycompanyId**](docs/Api/QueueApi.md#getqueuebycompanyid) | **GET** /getQueueBycompanyId | Get a customerâ€™s queue
*QueueApi* | [**getSingleCustomerQueue**](docs/Api/QueueApi.md#getsinglecustomerqueue) | **GET** /getQueueByCustomerId | Get a customerâ€™s queue
*RescheduleApi* | [**rescheduleCustomerAutomatic**](docs/Api/RescheduleApi.md#reschedulecustomerautomatic) | **POST** /rescheduleCustomerAutomatic | Reschedule Customer (Automatic)
*RescheduleApi* | [**rescheduleCustomerImmediate**](docs/Api/RescheduleApi.md#reschedulecustomerimmediate) | **POST** /rescheduleCustomerImmediate | Reschedule Customer (Send right away)
*RescheduleApi* | [**rescheduleManualOneReviewRequest**](docs/Api/RescheduleApi.md#reschedulemanualonereviewrequest) | **POST** /rescheduleManualOneReviewRequest | Reschedule Customer (Manual Schedule)
*ReviewSitesApi* | [**getAllReviewSitesByUserName**](docs/Api/ReviewSitesApi.md#getallreviewsitesbyusername) | **GET** /getAllReviewSitesByUserName | Get all review sites of an account
*ReviewSitesApi* | [**getAllReviewSitesBycompanyId**](docs/Api/ReviewSitesApi.md#getallreviewsitesbycompanyid) | **GET** /getAllReviewSitesBycompanyId | Get all review sites of a company
*ReviewsApi* | [**getCommentsonReview**](docs/Api/ReviewsApi.md#getcommentsonreview) | **GET** /getCommentsonReview | Get review comments
*ReviewsApi* | [**getReviewsByCompanyID**](docs/Api/ReviewsApi.md#getreviewsbycompanyid) | **GET** /getReviewsByCompanyID | Get X last reviews less than X days old of a company
*ReviewsApi* | [**getReviewsByCompanyIDAndReviewSite**](docs/Api/ReviewsApi.md#getreviewsbycompanyidandreviewsite) | **GET** /getReviewsByCompanyIDAndReviewSite | Get X last reviews less than X days old of a review site of a company
*ReviewsApi* | [**getReviewsByCompanyIDRatingAndReviewSite**](docs/Api/ReviewsApi.md#getreviewsbycompanyidratingandreviewsite) | **GET** /getReviewsByCompanyIDRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of a company
*ReviewsApi* | [**getReviewsByCompanyIdAndRating**](docs/Api/ReviewsApi.md#getreviewsbycompanyidandrating) | **GET** /getReviewsByCompanyIdAndRating | Get X last reviews that equal or over X stars of a company
*ReviewsApi* | [**getReviewsByUserName**](docs/Api/ReviewsApi.md#getreviewsbyusername) | **GET** /getReviewsByUserName | Get X last reviews less than X days old of an account
*ReviewsApi* | [**getReviewsByUserNameAndRating**](docs/Api/ReviewsApi.md#getreviewsbyusernameandrating) | **GET** /getReviewsByUserNameAndRating | Get X last reviews that equal or over X stars of an account
*ReviewsApi* | [**getReviewsByUserNameAndReviewSite**](docs/Api/ReviewsApi.md#getreviewsbyusernameandreviewsite) | **GET** /getReviewsByUserNameAndReviewSite | Get X last reviews less than X days old of a review site of an account
*ReviewsApi* | [**getReviewsByUserNameRatingAndReviewSite**](docs/Api/ReviewsApi.md#getreviewsbyusernameratingandreviewsite) | **GET** /getReviewsByUserNameRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of an account
*ReviewsApi* | [**postCommentOnReview**](docs/Api/ReviewsApi.md#postcommentonreview) | **POST** /postCommentOnReview | Comment on a Feedback / Review
*ReviewsStatsApi* | [**getNumberOfReviewsPostedInLastDaysByCompanyId**](docs/Api/ReviewsStatsApi.md#getnumberofreviewspostedinlastdaysbycompanyid) | **GET** /getNumberOfReviewsPostedInLastDaysByCompanyId | Get total reviews received for each review site
*ReviewsStatsApi* | [**getNumberOfReviewsRequiredToAchieve5StarByCompanyId**](docs/Api/ReviewsStatsApi.md#getnumberofreviewsrequiredtoachieve5starbycompanyid) | **GET** /getNumberOfReviewsRequiredToAchieve5StarByCompanyId | Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience
*ReviewsStatsApi* | [**getOverallRatingAndReviewCountForPlatformReviewsByCompanyId**](docs/Api/ReviewsStatsApi.md#getoverallratingandreviewcountforplatformreviewsbycompanyid) | **GET** /getOverallRatingAndReviewCountForPlatformReviewsByCompanyId | Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews
*ReviewsStatsApi* | [**getOverallRatingForEachReviewSiteByCompanyId**](docs/Api/ReviewsStatsApi.md#getoverallratingforeachreviewsitebycompanyid) | **GET** /getOverallRatingForEachReviewSiteByCompanyId | Get overall rating for each review site
*ReviewsStatsApi* | [**getOverallRatingOfCompanyByCompanyId**](docs/Api/ReviewsStatsApi.md#getoverallratingofcompanybycompanyid) | **GET** /getOverallRatingOfCompanyByCompanyId | Get The Overall Rating of a Company / Location / Feedback Page
*ReviewsStatsApi* | [**getOverallReputationChangeOfAllReviewSitesByCompanyId**](docs/Api/ReviewsStatsApi.md#getoverallreputationchangeofallreviewsitesbycompanyid) | **GET** /getOverallReputationChangeOfAllReviewSitesByCompanyId | Get the Overall Reputation Increase / Decrease of ALL Review Sites
*ReviewsStatsApi* | [**getTotalReviewsReceivedForEachReviewSiteByCompanyId**](docs/Api/ReviewsStatsApi.md#gettotalreviewsreceivedforeachreviewsitebycompanyid) | **GET** /getTotalReviewsReceivedForEachReviewSiteByCompanyId | Get total reviews received for each review site
*SentLogApi* | [**getSentLogByCompanyId**](docs/Api/SentLogApi.md#getsentlogbycompanyid) | **GET** /getSentLogByCompanyId | Get company&#39;s sent log
*SentLogApi* | [**getSentLogByCustomerId**](docs/Api/SentLogApi.md#getsentlogbycustomerid) | **GET** /getSentLogByCustomerId | Get a customerâ€™s sent log


## Documentation For Models

 - [Comment](docs/Model/Comment.md)
 - [Customer](docs/Model/Customer.md)
 - [CustomerWhoHaveNotResponded](docs/Model/CustomerWhoHaveNotResponded.md)
 - [EmailSmsSentCount](docs/Model/EmailSmsSentCount.md)
 - [EmailSmsSentLimit](docs/Model/EmailSmsSentLimit.md)
 - [Error](docs/Model/Error.md)
 - [OverallCompanyRating](docs/Model/OverallCompanyRating.md)
 - [OverallRatingAndReviewCount](docs/Model/OverallRatingAndReviewCount.md)
 - [Queue](docs/Model/Queue.md)
 - [Review](docs/Model/Review.md)
 - [ReviewSites](docs/Model/ReviewSites.md)
 - [ReviewSitesRating](docs/Model/ReviewSitesRating.md)
 - [ReviewSitesReputationChange](docs/Model/ReviewSitesReputationChange.md)
 - [ReviewSitesReviewCount](docs/Model/ReviewSitesReviewCount.md)
 - [SentLog](docs/Model/SentLog.md)


## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: key
- **Location**: HTTP header


## Author

support@reputationcrm.com


