# Swagger\Client\EmailSMSStatsApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getEmailSmsSentCount**](EmailSMSStatsApi.md#getEmailSmsSentCount) | **GET** /getEmailSmsSentCount | Email / SMS sent
[**getEmailSmsSentLimit**](EmailSMSStatsApi.md#getEmailSmsSentLimit) | **GET** /getEmailSmsSentLimit | Email / SMS Limit


# **getEmailSmsSentCount**
> \Swagger\Client\Model\EmailSmsSentCount[] getEmailSmsSentCount($username)

Email / SMS sent

Email / SMS sent

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: api_key
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('key', 'Bearer');

$apiInstance = new Swagger\Client\Api\EmailSMSStatsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$username = "username_example"; // string | User Name or Email address

try {
    $result = $apiInstance->getEmailSmsSentCount($username);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EmailSMSStatsApi->getEmailSmsSentCount: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**| User Name or Email address |

### Return type

[**\Swagger\Client\Model\EmailSmsSentCount[]**](../Model/EmailSmsSentCount.md)

### Authorization

[api_key](../../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getEmailSmsSentLimit**
> \Swagger\Client\Model\EmailSmsSentLimit[] getEmailSmsSentLimit($username)

Email / SMS Limit

Email / SMS Limit

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: api_key
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('key', 'Bearer');

$apiInstance = new Swagger\Client\Api\EmailSMSStatsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$username = "username_example"; // string | User Name or Email address

try {
    $result = $apiInstance->getEmailSmsSentLimit($username);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling EmailSMSStatsApi->getEmailSmsSentLimit: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**| User Name or Email address |

### Return type

[**\Swagger\Client\Model\EmailSmsSentLimit[]**](../Model/EmailSmsSentLimit.md)

### Authorization

[api_key](../../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

