<?php
/**
 * CustomerApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Reputation CRM API
 *
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/)
 *
 * OpenAPI spec version: 2.0.2
 * Contact: support@reputationcrm.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * CustomerApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation createCustomerAutomatic
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return string
     */
    public function createCustomerAutomatic($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        list($response) = $this->createCustomerAutomaticWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);
        return $response;
    }

    /**
     * Operation createCustomerAutomaticWithHttpInfo
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of string, HTTP status code, HTTP response headers (array of strings)
     */
    public function createCustomerAutomaticWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = 'string';
        $request = $this->createCustomerAutomaticRequest($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        'string',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation createCustomerAutomaticAsync
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerAutomaticAsync($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        return $this->createCustomerAutomaticAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createCustomerAutomaticAsyncWithHttpInfo
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerAutomaticAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = 'string';
        $request = $this->createCustomerAutomaticRequest($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createCustomerAutomatic'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createCustomerAutomaticRequest($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling createCustomerAutomatic'
            );
        }
        // verify the required parameter 'firstname' is set
        if ($firstname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $firstname when calling createCustomerAutomatic'
            );
        }
        // verify the required parameter 'lastname' is set
        if ($lastname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $lastname when calling createCustomerAutomatic'
            );
        }
        // verify the required parameter 'sendtype' is set
        if ($sendtype === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $sendtype when calling createCustomerAutomatic'
            );
        }

        $resourcePath = '/createCustomerAutomatic';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($companyid !== null) {
            $formParams['companyid'] = ObjectSerializer::toFormValue($companyid);
        }
        // form params
        if ($firstname !== null) {
            $formParams['firstname'] = ObjectSerializer::toFormValue($firstname);
        }
        // form params
        if ($lastname !== null) {
            $formParams['lastname'] = ObjectSerializer::toFormValue($lastname);
        }
        // form params
        if ($email !== null) {
            $formParams['email'] = ObjectSerializer::toFormValue($email);
        }
        // form params
        if ($mobile !== null) {
            $formParams['mobile'] = ObjectSerializer::toFormValue($mobile);
        }
        // form params
        if ($address !== null) {
            $formParams['address'] = ObjectSerializer::toFormValue($address);
        }
        // form params
        if ($zipcode !== null) {
            $formParams['zipcode'] = ObjectSerializer::toFormValue($zipcode);
        }
        // form params
        if ($city !== null) {
            $formParams['city'] = ObjectSerializer::toFormValue($city);
        }
        // form params
        if ($state !== null) {
            $formParams['state'] = ObjectSerializer::toFormValue($state);
        }
        // form params
        if ($country !== null) {
            $formParams['country'] = ObjectSerializer::toFormValue($country);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($sendtype !== null) {
            $formParams['sendtype'] = ObjectSerializer::toFormValue($sendtype);
        }
        // form params
        if ($notes !== null) {
            $formParams['notes'] = ObjectSerializer::toFormValue($notes);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation createCustomerAutomaticWithDelayReviewRequest
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function createCustomerAutomaticWithDelayReviewRequest($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $this->createCustomerAutomaticWithDelayReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);
    }

    /**
     * Operation createCustomerAutomaticWithDelayReviewRequestWithHttpInfo
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function createCustomerAutomaticWithDelayReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerAutomaticWithDelayReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation createCustomerAutomaticWithDelayReviewRequestAsync
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerAutomaticWithDelayReviewRequestAsync($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        return $this->createCustomerAutomaticWithDelayReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createCustomerAutomaticWithDelayReviewRequestAsyncWithHttpInfo
     *
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerAutomaticWithDelayReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerAutomaticWithDelayReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createCustomerAutomaticWithDelayReviewRequest'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createCustomerAutomaticWithDelayReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $delay_before_first_review_request, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling createCustomerAutomaticWithDelayReviewRequest'
            );
        }
        // verify the required parameter 'firstname' is set
        if ($firstname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $firstname when calling createCustomerAutomaticWithDelayReviewRequest'
            );
        }
        // verify the required parameter 'lastname' is set
        if ($lastname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $lastname when calling createCustomerAutomaticWithDelayReviewRequest'
            );
        }
        // verify the required parameter 'sendtype' is set
        if ($sendtype === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $sendtype when calling createCustomerAutomaticWithDelayReviewRequest'
            );
        }
        // verify the required parameter 'delay_before_first_review_request' is set
        if ($delay_before_first_review_request === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $delay_before_first_review_request when calling createCustomerAutomaticWithDelayReviewRequest'
            );
        }

        $resourcePath = '/createCustomerAutomaticWithDelayReviewRequest';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($companyid !== null) {
            $formParams['companyid'] = ObjectSerializer::toFormValue($companyid);
        }
        // form params
        if ($firstname !== null) {
            $formParams['firstname'] = ObjectSerializer::toFormValue($firstname);
        }
        // form params
        if ($lastname !== null) {
            $formParams['lastname'] = ObjectSerializer::toFormValue($lastname);
        }
        // form params
        if ($email !== null) {
            $formParams['email'] = ObjectSerializer::toFormValue($email);
        }
        // form params
        if ($mobile !== null) {
            $formParams['mobile'] = ObjectSerializer::toFormValue($mobile);
        }
        // form params
        if ($address !== null) {
            $formParams['address'] = ObjectSerializer::toFormValue($address);
        }
        // form params
        if ($zipcode !== null) {
            $formParams['zipcode'] = ObjectSerializer::toFormValue($zipcode);
        }
        // form params
        if ($city !== null) {
            $formParams['city'] = ObjectSerializer::toFormValue($city);
        }
        // form params
        if ($state !== null) {
            $formParams['state'] = ObjectSerializer::toFormValue($state);
        }
        // form params
        if ($country !== null) {
            $formParams['country'] = ObjectSerializer::toFormValue($country);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($sendtype !== null) {
            $formParams['sendtype'] = ObjectSerializer::toFormValue($sendtype);
        }
        // form params
        if ($notes !== null) {
            $formParams['notes'] = ObjectSerializer::toFormValue($notes);
        }
        // form params
        if ($delay_before_first_review_request !== null) {
            $formParams['delayBeforeFirstReviewRequest'] = ObjectSerializer::toFormValue($delay_before_first_review_request);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation createCustomerImmediateFirstReviewRequest
     *
     * Create a Customer AND Feedback / Review Requests
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function createCustomerImmediateFirstReviewRequest($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $this->createCustomerImmediateFirstReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);
    }

    /**
     * Operation createCustomerImmediateFirstReviewRequestWithHttpInfo
     *
     * Create a Customer AND Feedback / Review Requests
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function createCustomerImmediateFirstReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerImmediateFirstReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation createCustomerImmediateFirstReviewRequestAsync
     *
     * Create a Customer AND Feedback / Review Requests
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerImmediateFirstReviewRequestAsync($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        return $this->createCustomerImmediateFirstReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createCustomerImmediateFirstReviewRequestAsyncWithHttpInfo
     *
     * Create a Customer AND Feedback / Review Requests
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerImmediateFirstReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerImmediateFirstReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createCustomerImmediateFirstReviewRequest'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createCustomerImmediateFirstReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling createCustomerImmediateFirstReviewRequest'
            );
        }
        // verify the required parameter 'firstname' is set
        if ($firstname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $firstname when calling createCustomerImmediateFirstReviewRequest'
            );
        }
        // verify the required parameter 'lastname' is set
        if ($lastname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $lastname when calling createCustomerImmediateFirstReviewRequest'
            );
        }
        // verify the required parameter 'sendtype' is set
        if ($sendtype === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $sendtype when calling createCustomerImmediateFirstReviewRequest'
            );
        }

        $resourcePath = '/createCustomerImmediateFirstReviewRequest';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($companyid !== null) {
            $formParams['companyid'] = ObjectSerializer::toFormValue($companyid);
        }
        // form params
        if ($firstname !== null) {
            $formParams['firstname'] = ObjectSerializer::toFormValue($firstname);
        }
        // form params
        if ($lastname !== null) {
            $formParams['lastname'] = ObjectSerializer::toFormValue($lastname);
        }
        // form params
        if ($email !== null) {
            $formParams['email'] = ObjectSerializer::toFormValue($email);
        }
        // form params
        if ($mobile !== null) {
            $formParams['mobile'] = ObjectSerializer::toFormValue($mobile);
        }
        // form params
        if ($address !== null) {
            $formParams['address'] = ObjectSerializer::toFormValue($address);
        }
        // form params
        if ($zipcode !== null) {
            $formParams['zipcode'] = ObjectSerializer::toFormValue($zipcode);
        }
        // form params
        if ($city !== null) {
            $formParams['city'] = ObjectSerializer::toFormValue($city);
        }
        // form params
        if ($state !== null) {
            $formParams['state'] = ObjectSerializer::toFormValue($state);
        }
        // form params
        if ($country !== null) {
            $formParams['country'] = ObjectSerializer::toFormValue($country);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($sendtype !== null) {
            $formParams['sendtype'] = ObjectSerializer::toFormValue($sendtype);
        }
        // form params
        if ($notes !== null) {
            $formParams['notes'] = ObjectSerializer::toFormValue($notes);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation createCustomerManualScheduleOneReviewRequest
     *
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function createCustomerManualScheduleOneReviewRequest($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $this->createCustomerManualScheduleOneReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);
    }

    /**
     * Operation createCustomerManualScheduleOneReviewRequestWithHttpInfo
     *
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function createCustomerManualScheduleOneReviewRequestWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerManualScheduleOneReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation createCustomerManualScheduleOneReviewRequestAsync
     *
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerManualScheduleOneReviewRequestAsync($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        return $this->createCustomerManualScheduleOneReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createCustomerManualScheduleOneReviewRequestAsyncWithHttpInfo
     *
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerManualScheduleOneReviewRequestAsyncWithHttpInfo($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        $returnType = '';
        $request = $this->createCustomerManualScheduleOneReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email, $mobile, $address, $zipcode, $city, $state, $country, $language, $notes);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createCustomerManualScheduleOneReviewRequest'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt (optional)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (optional)
     * @param  string $notes Additional Customer Notes (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createCustomerManualScheduleOneReviewRequestRequest($companyid, $firstname, $lastname, $sendtype, $emailnumber, $smsnumber, $scheduledate, $scheduletime, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null, $notes = null)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'firstname' is set
        if ($firstname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $firstname when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'lastname' is set
        if ($lastname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $lastname when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'sendtype' is set
        if ($sendtype === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $sendtype when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'emailnumber' is set
        if ($emailnumber === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $emailnumber when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'smsnumber' is set
        if ($smsnumber === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $smsnumber when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'scheduledate' is set
        if ($scheduledate === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $scheduledate when calling createCustomerManualScheduleOneReviewRequest'
            );
        }
        // verify the required parameter 'scheduletime' is set
        if ($scheduletime === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $scheduletime when calling createCustomerManualScheduleOneReviewRequest'
            );
        }

        $resourcePath = '/createCustomerManualScheduleOneReviewRequest';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($companyid !== null) {
            $formParams['companyid'] = ObjectSerializer::toFormValue($companyid);
        }
        // form params
        if ($firstname !== null) {
            $formParams['firstname'] = ObjectSerializer::toFormValue($firstname);
        }
        // form params
        if ($lastname !== null) {
            $formParams['lastname'] = ObjectSerializer::toFormValue($lastname);
        }
        // form params
        if ($email !== null) {
            $formParams['email'] = ObjectSerializer::toFormValue($email);
        }
        // form params
        if ($mobile !== null) {
            $formParams['mobile'] = ObjectSerializer::toFormValue($mobile);
        }
        // form params
        if ($address !== null) {
            $formParams['address'] = ObjectSerializer::toFormValue($address);
        }
        // form params
        if ($zipcode !== null) {
            $formParams['zipcode'] = ObjectSerializer::toFormValue($zipcode);
        }
        // form params
        if ($city !== null) {
            $formParams['city'] = ObjectSerializer::toFormValue($city);
        }
        // form params
        if ($state !== null) {
            $formParams['state'] = ObjectSerializer::toFormValue($state);
        }
        // form params
        if ($country !== null) {
            $formParams['country'] = ObjectSerializer::toFormValue($country);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($sendtype !== null) {
            $formParams['sendtype'] = ObjectSerializer::toFormValue($sendtype);
        }
        // form params
        if ($notes !== null) {
            $formParams['notes'] = ObjectSerializer::toFormValue($notes);
        }
        // form params
        if ($emailnumber !== null) {
            $formParams['emailnumber'] = ObjectSerializer::toFormValue($emailnumber);
        }
        // form params
        if ($smsnumber !== null) {
            $formParams['smsnumber'] = ObjectSerializer::toFormValue($smsnumber);
        }
        // form params
        if ($scheduledate !== null) {
            $formParams['scheduledate'] = ObjectSerializer::toFormValue($scheduledate);
        }
        // form params
        if ($scheduletime !== null) {
            $formParams['scheduletime'] = ObjectSerializer::toFormValue($scheduletime);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deleteCustomer
     *
     * Delete ONE Customer record
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function deleteCustomer($customerid)
    {
        $this->deleteCustomerWithHttpInfo($customerid);
    }

    /**
     * Operation deleteCustomerWithHttpInfo
     *
     * Delete ONE Customer record
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteCustomerWithHttpInfo($customerid)
    {
        $returnType = '';
        $request = $this->deleteCustomerRequest($customerid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation deleteCustomerAsync
     *
     * Delete ONE Customer record
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteCustomerAsync($customerid)
    {
        return $this->deleteCustomerAsyncWithHttpInfo($customerid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteCustomerAsyncWithHttpInfo
     *
     * Delete ONE Customer record
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteCustomerAsyncWithHttpInfo($customerid)
    {
        $returnType = '';
        $request = $this->deleteCustomerRequest($customerid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteCustomer'
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteCustomerRequest($customerid)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling deleteCustomer'
            );
        }

        $resourcePath = '/deleteCustomer';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($customerid !== null) {
            $formParams['customerid'] = ObjectSerializer::toFormValue($customerid);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getAllCustomersBycompanyId
     *
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Customer[]
     */
    public function getAllCustomersBycompanyId($companyid)
    {
        list($response) = $this->getAllCustomersBycompanyIdWithHttpInfo($companyid);
        return $response;
    }

    /**
     * Operation getAllCustomersBycompanyIdWithHttpInfo
     *
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Customer[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getAllCustomersBycompanyIdWithHttpInfo($companyid)
    {
        $returnType = '\Swagger\Client\Model\Customer[]';
        $request = $this->getAllCustomersBycompanyIdRequest($companyid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Customer[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getAllCustomersBycompanyIdAsync
     *
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getAllCustomersBycompanyIdAsync($companyid)
    {
        return $this->getAllCustomersBycompanyIdAsyncWithHttpInfo($companyid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getAllCustomersBycompanyIdAsyncWithHttpInfo
     *
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getAllCustomersBycompanyIdAsyncWithHttpInfo($companyid)
    {
        $returnType = '\Swagger\Client\Model\Customer[]';
        $request = $this->getAllCustomersBycompanyIdRequest($companyid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getAllCustomersBycompanyId'
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getAllCustomersBycompanyIdRequest($companyid)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getAllCustomersBycompanyId'
            );
        }

        $resourcePath = '/getAllCustomersBycompanyId';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getCustomersWhoHaveNotYetSubmittedReview
     *
     * Get a list of Customers who have not yet submitted their Review / Feedback
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\CustomerWhoHaveNotResponded[]
     */
    public function getCustomersWhoHaveNotYetSubmittedReview($companyid)
    {
        list($response) = $this->getCustomersWhoHaveNotYetSubmittedReviewWithHttpInfo($companyid);
        return $response;
    }

    /**
     * Operation getCustomersWhoHaveNotYetSubmittedReviewWithHttpInfo
     *
     * Get a list of Customers who have not yet submitted their Review / Feedback
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\CustomerWhoHaveNotResponded[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getCustomersWhoHaveNotYetSubmittedReviewWithHttpInfo($companyid)
    {
        $returnType = '\Swagger\Client\Model\CustomerWhoHaveNotResponded[]';
        $request = $this->getCustomersWhoHaveNotYetSubmittedReviewRequest($companyid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\CustomerWhoHaveNotResponded[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getCustomersWhoHaveNotYetSubmittedReviewAsync
     *
     * Get a list of Customers who have not yet submitted their Review / Feedback
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getCustomersWhoHaveNotYetSubmittedReviewAsync($companyid)
    {
        return $this->getCustomersWhoHaveNotYetSubmittedReviewAsyncWithHttpInfo($companyid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getCustomersWhoHaveNotYetSubmittedReviewAsyncWithHttpInfo
     *
     * Get a list of Customers who have not yet submitted their Review / Feedback
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getCustomersWhoHaveNotYetSubmittedReviewAsyncWithHttpInfo($companyid)
    {
        $returnType = '\Swagger\Client\Model\CustomerWhoHaveNotResponded[]';
        $request = $this->getCustomersWhoHaveNotYetSubmittedReviewRequest($companyid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getCustomersWhoHaveNotYetSubmittedReview'
     *
     * @param  string $companyid Company ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getCustomersWhoHaveNotYetSubmittedReviewRequest($companyid)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getCustomersWhoHaveNotYetSubmittedReview'
            );
        }

        $resourcePath = '/getCustomersWhoHaveNotYetSubmittedReview';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getSingleCustomer
     *
     * Get Information of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Customer[]
     */
    public function getSingleCustomer($customerid)
    {
        list($response) = $this->getSingleCustomerWithHttpInfo($customerid);
        return $response;
    }

    /**
     * Operation getSingleCustomerWithHttpInfo
     *
     * Get Information of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Customer[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getSingleCustomerWithHttpInfo($customerid)
    {
        $returnType = '\Swagger\Client\Model\Customer[]';
        $request = $this->getSingleCustomerRequest($customerid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Customer[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getSingleCustomerAsync
     *
     * Get Information of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getSingleCustomerAsync($customerid)
    {
        return $this->getSingleCustomerAsyncWithHttpInfo($customerid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getSingleCustomerAsyncWithHttpInfo
     *
     * Get Information of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getSingleCustomerAsyncWithHttpInfo($customerid)
    {
        $returnType = '\Swagger\Client\Model\Customer[]';
        $request = $this->getSingleCustomerRequest($customerid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getSingleCustomer'
     *
     * @param  string $customerid Customer ID (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getSingleCustomerRequest($customerid)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling getSingleCustomer'
            );
        }

        $resourcePath = '/getSingleCustomer';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($customerid !== null) {
            $queryParams['customerid'] = ObjectSerializer::toQueryValue($customerid);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation updateCustomer
     *
     * Update the record of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $notes Additional Customer Notes (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country (optional)
     * @param  string $language Customer Language (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function updateCustomer($customerid, $firstname, $lastname, $notes, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null)
    {
        $this->updateCustomerWithHttpInfo($customerid, $firstname, $lastname, $notes, $email, $mobile, $address, $zipcode, $city, $state, $country, $language);
    }

    /**
     * Operation updateCustomerWithHttpInfo
     *
     * Update the record of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $notes Additional Customer Notes (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country (optional)
     * @param  string $language Customer Language (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function updateCustomerWithHttpInfo($customerid, $firstname, $lastname, $notes, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null)
    {
        $returnType = '';
        $request = $this->updateCustomerRequest($customerid, $firstname, $lastname, $notes, $email, $mobile, $address, $zipcode, $city, $state, $country, $language);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation updateCustomerAsync
     *
     * Update the record of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $notes Additional Customer Notes (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country (optional)
     * @param  string $language Customer Language (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updateCustomerAsync($customerid, $firstname, $lastname, $notes, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null)
    {
        return $this->updateCustomerAsyncWithHttpInfo($customerid, $firstname, $lastname, $notes, $email, $mobile, $address, $zipcode, $city, $state, $country, $language)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation updateCustomerAsyncWithHttpInfo
     *
     * Update the record of ONE Customer
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $notes Additional Customer Notes (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country (optional)
     * @param  string $language Customer Language (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updateCustomerAsyncWithHttpInfo($customerid, $firstname, $lastname, $notes, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null)
    {
        $returnType = '';
        $request = $this->updateCustomerRequest($customerid, $firstname, $lastname, $notes, $email, $mobile, $address, $zipcode, $city, $state, $country, $language);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'updateCustomer'
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $firstname Customer First Name (required)
     * @param  string $lastname Customer Last Name (required)
     * @param  string $notes Additional Customer Notes (required)
     * @param  string $email Customer Email (optional)
     * @param  string $mobile Customer Mobile Phone (optional)
     * @param  string $address Customer Postal Address (optional)
     * @param  string $zipcode Customer Zipcode (optional)
     * @param  string $city Customer City (optional)
     * @param  string $state Customer State / Province / Region (optional)
     * @param  string $country Customer Country (optional)
     * @param  string $language Customer Language (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function updateCustomerRequest($customerid, $firstname, $lastname, $notes, $email = null, $mobile = null, $address = null, $zipcode = null, $city = null, $state = null, $country = null, $language = null)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling updateCustomer'
            );
        }
        // verify the required parameter 'firstname' is set
        if ($firstname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $firstname when calling updateCustomer'
            );
        }
        // verify the required parameter 'lastname' is set
        if ($lastname === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $lastname when calling updateCustomer'
            );
        }
        // verify the required parameter 'notes' is set
        if ($notes === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $notes when calling updateCustomer'
            );
        }

        $resourcePath = '/updateCustomer';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($customerid !== null) {
            $formParams['customerid'] = ObjectSerializer::toFormValue($customerid);
        }
        // form params
        if ($firstname !== null) {
            $formParams['firstname'] = ObjectSerializer::toFormValue($firstname);
        }
        // form params
        if ($lastname !== null) {
            $formParams['lastname'] = ObjectSerializer::toFormValue($lastname);
        }
        // form params
        if ($email !== null) {
            $formParams['email'] = ObjectSerializer::toFormValue($email);
        }
        // form params
        if ($mobile !== null) {
            $formParams['mobile'] = ObjectSerializer::toFormValue($mobile);
        }
        // form params
        if ($address !== null) {
            $formParams['address'] = ObjectSerializer::toFormValue($address);
        }
        // form params
        if ($zipcode !== null) {
            $formParams['zipcode'] = ObjectSerializer::toFormValue($zipcode);
        }
        // form params
        if ($city !== null) {
            $formParams['city'] = ObjectSerializer::toFormValue($city);
        }
        // form params
        if ($state !== null) {
            $formParams['state'] = ObjectSerializer::toFormValue($state);
        }
        // form params
        if ($country !== null) {
            $formParams['country'] = ObjectSerializer::toFormValue($country);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($notes !== null) {
            $formParams['notes'] = ObjectSerializer::toFormValue($notes);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'PUT',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
