<?php
/**
 * RescheduleApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Reputation CRM API
 *
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/)
 *
 * OpenAPI spec version: 2.0.2
 * Contact: support@reputationcrm.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * RescheduleApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class RescheduleApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation rescheduleCustomerAutomatic
     *
     * Reschedule Customer (Automatic)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function rescheduleCustomerAutomatic($customerid, $language)
    {
        $this->rescheduleCustomerAutomaticWithHttpInfo($customerid, $language);
    }

    /**
     * Operation rescheduleCustomerAutomaticWithHttpInfo
     *
     * Reschedule Customer (Automatic)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function rescheduleCustomerAutomaticWithHttpInfo($customerid, $language)
    {
        $returnType = '';
        $request = $this->rescheduleCustomerAutomaticRequest($customerid, $language);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation rescheduleCustomerAutomaticAsync
     *
     * Reschedule Customer (Automatic)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleCustomerAutomaticAsync($customerid, $language)
    {
        return $this->rescheduleCustomerAutomaticAsyncWithHttpInfo($customerid, $language)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation rescheduleCustomerAutomaticAsyncWithHttpInfo
     *
     * Reschedule Customer (Automatic)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleCustomerAutomaticAsyncWithHttpInfo($customerid, $language)
    {
        $returnType = '';
        $request = $this->rescheduleCustomerAutomaticRequest($customerid, $language);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'rescheduleCustomerAutomatic'
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function rescheduleCustomerAutomaticRequest($customerid, $language)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling rescheduleCustomerAutomatic'
            );
        }
        // verify the required parameter 'language' is set
        if ($language === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $language when calling rescheduleCustomerAutomatic'
            );
        }

        $resourcePath = '/rescheduleCustomerAutomatic';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($customerid !== null) {
            $formParams['customerid'] = ObjectSerializer::toFormValue($customerid);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation rescheduleCustomerImmediate
     *
     * Reschedule Customer (Send right away)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function rescheduleCustomerImmediate($customerid, $language)
    {
        $this->rescheduleCustomerImmediateWithHttpInfo($customerid, $language);
    }

    /**
     * Operation rescheduleCustomerImmediateWithHttpInfo
     *
     * Reschedule Customer (Send right away)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function rescheduleCustomerImmediateWithHttpInfo($customerid, $language)
    {
        $returnType = '';
        $request = $this->rescheduleCustomerImmediateRequest($customerid, $language);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation rescheduleCustomerImmediateAsync
     *
     * Reschedule Customer (Send right away)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleCustomerImmediateAsync($customerid, $language)
    {
        return $this->rescheduleCustomerImmediateAsyncWithHttpInfo($customerid, $language)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation rescheduleCustomerImmediateAsyncWithHttpInfo
     *
     * Reschedule Customer (Send right away)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleCustomerImmediateAsyncWithHttpInfo($customerid, $language)
    {
        $returnType = '';
        $request = $this->rescheduleCustomerImmediateRequest($customerid, $language);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'rescheduleCustomerImmediate'
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function rescheduleCustomerImmediateRequest($customerid, $language)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling rescheduleCustomerImmediate'
            );
        }
        // verify the required parameter 'language' is set
        if ($language === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $language when calling rescheduleCustomerImmediate'
            );
        }

        $resourcePath = '/rescheduleCustomerImmediate';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($customerid !== null) {
            $formParams['customerid'] = ObjectSerializer::toFormValue($customerid);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation rescheduleManualOneReviewRequest
     *
     * Reschedule Customer (Manual Schedule)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function rescheduleManualOneReviewRequest($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
    {
        $this->rescheduleManualOneReviewRequestWithHttpInfo($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber);
    }

    /**
     * Operation rescheduleManualOneReviewRequestWithHttpInfo
     *
     * Reschedule Customer (Manual Schedule)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function rescheduleManualOneReviewRequestWithHttpInfo($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
    {
        $returnType = '';
        $request = $this->rescheduleManualOneReviewRequestRequest($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation rescheduleManualOneReviewRequestAsync
     *
     * Reschedule Customer (Manual Schedule)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleManualOneReviewRequestAsync($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
    {
        return $this->rescheduleManualOneReviewRequestAsyncWithHttpInfo($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation rescheduleManualOneReviewRequestAsyncWithHttpInfo
     *
     * Reschedule Customer (Manual Schedule)
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function rescheduleManualOneReviewRequestAsyncWithHttpInfo($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
    {
        $returnType = '';
        $request = $this->rescheduleManualOneReviewRequestRequest($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'rescheduleManualOneReviewRequest'
     *
     * @param  string $customerid Customer ID (required)
     * @param  string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages (required)
     * @param  string $scheduledate Schedule date (yyyy/mm/dd) (required)
     * @param  string $scheduletime Schedule time (HH:MM 24 hours format) (required)
     * @param  string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     * @param  string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function rescheduleManualOneReviewRequestRequest($customerid, $language, $scheduledate, $scheduletime, $emailnumber, $smsnumber)
    {
        // verify the required parameter 'customerid' is set
        if ($customerid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customerid when calling rescheduleManualOneReviewRequest'
            );
        }
        // verify the required parameter 'language' is set
        if ($language === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $language when calling rescheduleManualOneReviewRequest'
            );
        }
        // verify the required parameter 'scheduledate' is set
        if ($scheduledate === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $scheduledate when calling rescheduleManualOneReviewRequest'
            );
        }
        // verify the required parameter 'scheduletime' is set
        if ($scheduletime === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $scheduletime when calling rescheduleManualOneReviewRequest'
            );
        }
        // verify the required parameter 'emailnumber' is set
        if ($emailnumber === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $emailnumber when calling rescheduleManualOneReviewRequest'
            );
        }
        // verify the required parameter 'smsnumber' is set
        if ($smsnumber === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $smsnumber when calling rescheduleManualOneReviewRequest'
            );
        }

        $resourcePath = '/rescheduleManualOneReviewRequest';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($customerid !== null) {
            $formParams['customerid'] = ObjectSerializer::toFormValue($customerid);
        }
        // form params
        if ($language !== null) {
            $formParams['language'] = ObjectSerializer::toFormValue($language);
        }
        // form params
        if ($scheduledate !== null) {
            $formParams['scheduledate'] = ObjectSerializer::toFormValue($scheduledate);
        }
        // form params
        if ($scheduletime !== null) {
            $formParams['scheduletime'] = ObjectSerializer::toFormValue($scheduletime);
        }
        // form params
        if ($emailnumber !== null) {
            $formParams['emailnumber'] = ObjectSerializer::toFormValue($emailnumber);
        }
        // form params
        if ($smsnumber !== null) {
            $formParams['smsnumber'] = ObjectSerializer::toFormValue($smsnumber);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
