<?php
/**
 * ReviewsApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Reputation CRM API
 *
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/)
 *
 * OpenAPI spec version: 2.0.2
 * Contact: support@reputationcrm.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * ReviewsApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ReviewsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation getCommentsonReview
     *
     * Get review comments
     *
     * @param  string $companyid Company ID (optional)
     * @param  string $reviewid Review ID (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Comment[]
     */
    public function getCommentsonReview($companyid = null, $reviewid = null)
    {
        list($response) = $this->getCommentsonReviewWithHttpInfo($companyid, $reviewid);
        return $response;
    }

    /**
     * Operation getCommentsonReviewWithHttpInfo
     *
     * Get review comments
     *
     * @param  string $companyid Company ID (optional)
     * @param  string $reviewid Review ID (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Comment[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getCommentsonReviewWithHttpInfo($companyid = null, $reviewid = null)
    {
        $returnType = '\Swagger\Client\Model\Comment[]';
        $request = $this->getCommentsonReviewRequest($companyid, $reviewid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Comment[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getCommentsonReviewAsync
     *
     * Get review comments
     *
     * @param  string $companyid Company ID (optional)
     * @param  string $reviewid Review ID (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getCommentsonReviewAsync($companyid = null, $reviewid = null)
    {
        return $this->getCommentsonReviewAsyncWithHttpInfo($companyid, $reviewid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getCommentsonReviewAsyncWithHttpInfo
     *
     * Get review comments
     *
     * @param  string $companyid Company ID (optional)
     * @param  string $reviewid Review ID (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getCommentsonReviewAsyncWithHttpInfo($companyid = null, $reviewid = null)
    {
        $returnType = '\Swagger\Client\Model\Comment[]';
        $request = $this->getCommentsonReviewRequest($companyid, $reviewid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getCommentsonReview'
     *
     * @param  string $companyid Company ID (optional)
     * @param  string $reviewid Review ID (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getCommentsonReviewRequest($companyid = null, $reviewid = null)
    {

        $resourcePath = '/getCommentsonReview';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }
        // query params
        if ($reviewid !== null) {
            $queryParams['reviewid'] = ObjectSerializer::toQueryValue($reviewid);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByCompanyID
     *
     * Get X last reviews less than X days old of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByCompanyID($companyid, $how_many_reviews, $last_how_many_days)
    {
        list($response) = $this->getReviewsByCompanyIDWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days);
        return $response;
    }

    /**
     * Operation getReviewsByCompanyIDWithHttpInfo
     *
     * Get X last reviews less than X days old of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByCompanyIDWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDRequest($companyid, $how_many_reviews, $last_how_many_days);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByCompanyIDAsync
     *
     * Get X last reviews less than X days old of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDAsync($companyid, $how_many_reviews, $last_how_many_days)
    {
        return $this->getReviewsByCompanyIDAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByCompanyIDAsyncWithHttpInfo
     *
     * Get X last reviews less than X days old of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDRequest($companyid, $how_many_reviews, $last_how_many_days);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByCompanyID'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByCompanyIDRequest($companyid, $how_many_reviews, $last_how_many_days)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getReviewsByCompanyID'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByCompanyID'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByCompanyID'
            );
        }

        $resourcePath = '/getReviewsByCompanyID';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByCompanyIDAndReviewSite
     *
     * Get X last reviews less than X days old of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByCompanyIDAndReviewSite($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        list($response) = $this->getReviewsByCompanyIDAndReviewSiteWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $reviews_site);
        return $response;
    }

    /**
     * Operation getReviewsByCompanyIDAndReviewSiteWithHttpInfo
     *
     * Get X last reviews less than X days old of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByCompanyIDAndReviewSiteWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDAndReviewSiteRequest($companyid, $how_many_reviews, $last_how_many_days, $reviews_site);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByCompanyIDAndReviewSiteAsync
     *
     * Get X last reviews less than X days old of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDAndReviewSiteAsync($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        return $this->getReviewsByCompanyIDAndReviewSiteAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByCompanyIDAndReviewSiteAsyncWithHttpInfo
     *
     * Get X last reviews less than X days old of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDAndReviewSiteAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDAndReviewSiteRequest($companyid, $how_many_reviews, $last_how_many_days, $reviews_site);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByCompanyIDAndReviewSite'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByCompanyIDAndReviewSiteRequest($companyid, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getReviewsByCompanyIDAndReviewSite'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByCompanyIDAndReviewSite'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByCompanyIDAndReviewSite'
            );
        }
        // verify the required parameter 'reviews_site' is set
        if ($reviews_site === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reviews_site when calling getReviewsByCompanyIDAndReviewSite'
            );
        }

        $resourcePath = '/getReviewsByCompanyIDAndReviewSite';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }
        // query params
        if ($reviews_site !== null) {
            $queryParams['reviewsSite'] = ObjectSerializer::toQueryValue($reviews_site);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByCompanyIDRatingAndReviewSite
     *
     * Get X last reviews that equal or over X stars of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByCompanyIDRatingAndReviewSite($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        list($response) = $this->getReviewsByCompanyIDRatingAndReviewSiteWithHttpInfo($companyid, $how_many_reviews, $minimum_ratings, $reviews_site);
        return $response;
    }

    /**
     * Operation getReviewsByCompanyIDRatingAndReviewSiteWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByCompanyIDRatingAndReviewSiteWithHttpInfo($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDRatingAndReviewSiteRequest($companyid, $how_many_reviews, $minimum_ratings, $reviews_site);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByCompanyIDRatingAndReviewSiteAsync
     *
     * Get X last reviews that equal or over X stars of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDRatingAndReviewSiteAsync($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        return $this->getReviewsByCompanyIDRatingAndReviewSiteAsyncWithHttpInfo($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByCompanyIDRatingAndReviewSiteAsyncWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a review site of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIDRatingAndReviewSiteAsyncWithHttpInfo($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIDRatingAndReviewSiteRequest($companyid, $how_many_reviews, $minimum_ratings, $reviews_site);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByCompanyIDRatingAndReviewSite'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByCompanyIDRatingAndReviewSiteRequest($companyid, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getReviewsByCompanyIDRatingAndReviewSite'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByCompanyIDRatingAndReviewSite'
            );
        }
        // verify the required parameter 'minimum_ratings' is set
        if ($minimum_ratings === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $minimum_ratings when calling getReviewsByCompanyIDRatingAndReviewSite'
            );
        }
        // verify the required parameter 'reviews_site' is set
        if ($reviews_site === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reviews_site when calling getReviewsByCompanyIDRatingAndReviewSite'
            );
        }

        $resourcePath = '/getReviewsByCompanyIDRatingAndReviewSite';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($minimum_ratings !== null) {
            $queryParams['minimumRatings'] = ObjectSerializer::toQueryValue($minimum_ratings);
        }
        // query params
        if ($reviews_site !== null) {
            $queryParams['reviewsSite'] = ObjectSerializer::toQueryValue($reviews_site);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByCompanyIdAndRating
     *
     * Get X last reviews that equal or over X stars of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $maximum_ratings Maximum review rating (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByCompanyIdAndRating($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
    {
        list($response) = $this->getReviewsByCompanyIdAndRatingWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings);
        return $response;
    }

    /**
     * Operation getReviewsByCompanyIdAndRatingWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $maximum_ratings Maximum review rating (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByCompanyIdAndRatingWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIdAndRatingRequest($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByCompanyIdAndRatingAsync
     *
     * Get X last reviews that equal or over X stars of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $maximum_ratings Maximum review rating (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIdAndRatingAsync($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
    {
        return $this->getReviewsByCompanyIdAndRatingAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByCompanyIdAndRatingAsyncWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a company
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $maximum_ratings Maximum review rating (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByCompanyIdAndRatingAsyncWithHttpInfo($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByCompanyIdAndRatingRequest($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByCompanyIdAndRating'
     *
     * @param  string $companyid Company ID (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $maximum_ratings Maximum review rating (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByCompanyIdAndRatingRequest($companyid, $how_many_reviews, $last_how_many_days, $minimum_ratings, $maximum_ratings)
    {
        // verify the required parameter 'companyid' is set
        if ($companyid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $companyid when calling getReviewsByCompanyIdAndRating'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByCompanyIdAndRating'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByCompanyIdAndRating'
            );
        }
        // verify the required parameter 'minimum_ratings' is set
        if ($minimum_ratings === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $minimum_ratings when calling getReviewsByCompanyIdAndRating'
            );
        }
        // verify the required parameter 'maximum_ratings' is set
        if ($maximum_ratings === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $maximum_ratings when calling getReviewsByCompanyIdAndRating'
            );
        }

        $resourcePath = '/getReviewsByCompanyIdAndRating';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($companyid !== null) {
            $queryParams['companyid'] = ObjectSerializer::toQueryValue($companyid);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }
        // query params
        if ($minimum_ratings !== null) {
            $queryParams['minimumRatings'] = ObjectSerializer::toQueryValue($minimum_ratings);
        }
        // query params
        if ($maximum_ratings !== null) {
            $queryParams['maximumRatings'] = ObjectSerializer::toQueryValue($maximum_ratings);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByUserName
     *
     * Get X last reviews less than X days old of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByUserName($username, $how_many_reviews, $last_how_many_days)
    {
        list($response) = $this->getReviewsByUserNameWithHttpInfo($username, $how_many_reviews, $last_how_many_days);
        return $response;
    }

    /**
     * Operation getReviewsByUserNameWithHttpInfo
     *
     * Get X last reviews less than X days old of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByUserNameWithHttpInfo($username, $how_many_reviews, $last_how_many_days)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameRequest($username, $how_many_reviews, $last_how_many_days);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByUserNameAsync
     *
     * Get X last reviews less than X days old of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAsync($username, $how_many_reviews, $last_how_many_days)
    {
        return $this->getReviewsByUserNameAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByUserNameAsyncWithHttpInfo
     *
     * Get X last reviews less than X days old of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameRequest($username, $how_many_reviews, $last_how_many_days);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByUserName'
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByUserNameRequest($username, $how_many_reviews, $last_how_many_days)
    {
        // verify the required parameter 'username' is set
        if ($username === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $username when calling getReviewsByUserName'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByUserName'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByUserName'
            );
        }

        $resourcePath = '/getReviewsByUserName';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($username !== null) {
            $queryParams['username'] = ObjectSerializer::toQueryValue($username);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByUserNameAndRating
     *
     * Get X last reviews that equal or over X stars of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByUserNameAndRating($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
    {
        list($response) = $this->getReviewsByUserNameAndRatingWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $minimum_ratings);
        return $response;
    }

    /**
     * Operation getReviewsByUserNameAndRatingWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByUserNameAndRatingWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameAndRatingRequest($username, $how_many_reviews, $last_how_many_days, $minimum_ratings);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByUserNameAndRatingAsync
     *
     * Get X last reviews that equal or over X stars of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAndRatingAsync($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
    {
        return $this->getReviewsByUserNameAndRatingAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByUserNameAndRatingAsyncWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAndRatingAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameAndRatingRequest($username, $how_many_reviews, $last_how_many_days, $minimum_ratings);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByUserNameAndRating'
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByUserNameAndRatingRequest($username, $how_many_reviews, $last_how_many_days, $minimum_ratings)
    {
        // verify the required parameter 'username' is set
        if ($username === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $username when calling getReviewsByUserNameAndRating'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByUserNameAndRating'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByUserNameAndRating'
            );
        }
        // verify the required parameter 'minimum_ratings' is set
        if ($minimum_ratings === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $minimum_ratings when calling getReviewsByUserNameAndRating'
            );
        }

        $resourcePath = '/getReviewsByUserNameAndRating';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($username !== null) {
            $queryParams['username'] = ObjectSerializer::toQueryValue($username);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }
        // query params
        if ($minimum_ratings !== null) {
            $queryParams['minimumRatings'] = ObjectSerializer::toQueryValue($minimum_ratings);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByUserNameAndReviewSite
     *
     * Get X last reviews less than X days old of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByUserNameAndReviewSite($username, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        list($response) = $this->getReviewsByUserNameAndReviewSiteWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $reviews_site);
        return $response;
    }

    /**
     * Operation getReviewsByUserNameAndReviewSiteWithHttpInfo
     *
     * Get X last reviews less than X days old of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByUserNameAndReviewSiteWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameAndReviewSiteRequest($username, $how_many_reviews, $last_how_many_days, $reviews_site);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByUserNameAndReviewSiteAsync
     *
     * Get X last reviews less than X days old of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAndReviewSiteAsync($username, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        return $this->getReviewsByUserNameAndReviewSiteAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $reviews_site)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByUserNameAndReviewSiteAsyncWithHttpInfo
     *
     * Get X last reviews less than X days old of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameAndReviewSiteAsyncWithHttpInfo($username, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameAndReviewSiteRequest($username, $how_many_reviews, $last_how_many_days, $reviews_site);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByUserNameAndReviewSite'
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $last_how_many_days How many days back (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByUserNameAndReviewSiteRequest($username, $how_many_reviews, $last_how_many_days, $reviews_site)
    {
        // verify the required parameter 'username' is set
        if ($username === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $username when calling getReviewsByUserNameAndReviewSite'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByUserNameAndReviewSite'
            );
        }
        // verify the required parameter 'last_how_many_days' is set
        if ($last_how_many_days === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $last_how_many_days when calling getReviewsByUserNameAndReviewSite'
            );
        }
        // verify the required parameter 'reviews_site' is set
        if ($reviews_site === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reviews_site when calling getReviewsByUserNameAndReviewSite'
            );
        }

        $resourcePath = '/getReviewsByUserNameAndReviewSite';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($username !== null) {
            $queryParams['username'] = ObjectSerializer::toQueryValue($username);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($last_how_many_days !== null) {
            $queryParams['lastHowManyDays'] = ObjectSerializer::toQueryValue($last_how_many_days);
        }
        // query params
        if ($reviews_site !== null) {
            $queryParams['reviewsSite'] = ObjectSerializer::toQueryValue($reviews_site);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getReviewsByUserNameRatingAndReviewSite
     *
     * Get X last reviews that equal or over X stars of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Review[]
     */
    public function getReviewsByUserNameRatingAndReviewSite($username, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        list($response) = $this->getReviewsByUserNameRatingAndReviewSiteWithHttpInfo($username, $how_many_reviews, $minimum_ratings, $reviews_site);
        return $response;
    }

    /**
     * Operation getReviewsByUserNameRatingAndReviewSiteWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Review[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReviewsByUserNameRatingAndReviewSiteWithHttpInfo($username, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameRatingAndReviewSiteRequest($username, $how_many_reviews, $minimum_ratings, $reviews_site);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Review[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getReviewsByUserNameRatingAndReviewSiteAsync
     *
     * Get X last reviews that equal or over X stars of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameRatingAndReviewSiteAsync($username, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        return $this->getReviewsByUserNameRatingAndReviewSiteAsyncWithHttpInfo($username, $how_many_reviews, $minimum_ratings, $reviews_site)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getReviewsByUserNameRatingAndReviewSiteAsyncWithHttpInfo
     *
     * Get X last reviews that equal or over X stars of a review site of an account
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getReviewsByUserNameRatingAndReviewSiteAsyncWithHttpInfo($username, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        $returnType = '\Swagger\Client\Model\Review[]';
        $request = $this->getReviewsByUserNameRatingAndReviewSiteRequest($username, $how_many_reviews, $minimum_ratings, $reviews_site);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getReviewsByUserNameRatingAndReviewSite'
     *
     * @param  string $username User Name or Email address (required)
     * @param  string $how_many_reviews How many reviews (required)
     * @param  string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param  string $reviews_site Review site name (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getReviewsByUserNameRatingAndReviewSiteRequest($username, $how_many_reviews, $minimum_ratings, $reviews_site)
    {
        // verify the required parameter 'username' is set
        if ($username === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $username when calling getReviewsByUserNameRatingAndReviewSite'
            );
        }
        // verify the required parameter 'how_many_reviews' is set
        if ($how_many_reviews === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $how_many_reviews when calling getReviewsByUserNameRatingAndReviewSite'
            );
        }
        // verify the required parameter 'minimum_ratings' is set
        if ($minimum_ratings === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $minimum_ratings when calling getReviewsByUserNameRatingAndReviewSite'
            );
        }
        // verify the required parameter 'reviews_site' is set
        if ($reviews_site === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reviews_site when calling getReviewsByUserNameRatingAndReviewSite'
            );
        }

        $resourcePath = '/getReviewsByUserNameRatingAndReviewSite';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($username !== null) {
            $queryParams['username'] = ObjectSerializer::toQueryValue($username);
        }
        // query params
        if ($how_many_reviews !== null) {
            $queryParams['howManyReviews'] = ObjectSerializer::toQueryValue($how_many_reviews);
        }
        // query params
        if ($minimum_ratings !== null) {
            $queryParams['minimumRatings'] = ObjectSerializer::toQueryValue($minimum_ratings);
        }
        // query params
        if ($reviews_site !== null) {
            $queryParams['reviewsSite'] = ObjectSerializer::toQueryValue($reviews_site);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postCommentOnReview
     *
     * Comment on a Feedback / Review
     *
     * @param  string $reviewid Review ID (required)
     * @param  string $commenttext Comment Text (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function postCommentOnReview($reviewid, $commenttext)
    {
        $this->postCommentOnReviewWithHttpInfo($reviewid, $commenttext);
    }

    /**
     * Operation postCommentOnReviewWithHttpInfo
     *
     * Comment on a Feedback / Review
     *
     * @param  string $reviewid Review ID (required)
     * @param  string $commenttext Comment Text (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function postCommentOnReviewWithHttpInfo($reviewid, $commenttext)
    {
        $returnType = '';
        $request = $this->postCommentOnReviewRequest($reviewid, $commenttext);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation postCommentOnReviewAsync
     *
     * Comment on a Feedback / Review
     *
     * @param  string $reviewid Review ID (required)
     * @param  string $commenttext Comment Text (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postCommentOnReviewAsync($reviewid, $commenttext)
    {
        return $this->postCommentOnReviewAsyncWithHttpInfo($reviewid, $commenttext)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postCommentOnReviewAsyncWithHttpInfo
     *
     * Comment on a Feedback / Review
     *
     * @param  string $reviewid Review ID (required)
     * @param  string $commenttext Comment Text (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postCommentOnReviewAsyncWithHttpInfo($reviewid, $commenttext)
    {
        $returnType = '';
        $request = $this->postCommentOnReviewRequest($reviewid, $commenttext);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postCommentOnReview'
     *
     * @param  string $reviewid Review ID (required)
     * @param  string $commenttext Comment Text (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postCommentOnReviewRequest($reviewid, $commenttext)
    {
        // verify the required parameter 'reviewid' is set
        if ($reviewid === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reviewid when calling postCommentOnReview'
            );
        }
        // verify the required parameter 'commenttext' is set
        if ($commenttext === null) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $commenttext when calling postCommentOnReview'
            );
        }

        $resourcePath = '/postCommentOnReview';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($reviewid !== null) {
            $formParams['reviewid'] = ObjectSerializer::toFormValue($reviewid);
        }
        // form params
        if ($commenttext !== null) {
            $formParams['commenttext'] = ObjectSerializer::toFormValue($commenttext);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'application/xml']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'application/xml'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('key');
        if ($apiKey !== null) {
            $headers['key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
